﻿using System;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Configuration;

namespace MapApplication.Web
{
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class RadMapTokenService
    {
        // Staging Environment Token Service URL -- use this for development
        private const string StagingTokenServiceUri = "http://staging.common.virtualearth.net/find-30/common.asmx";
        
        // Production Environment Token Service URL -- use this for deployment
        //private const string ProductionTokenServiceUri = "https://common.virtualearth.net/find-30/common.asmx";

        [OperationContract]
        public string GetToken()
        {
            string token = string.Empty;

            // Initialize VE token service
            VETokenService.CommonService tokenService = new VETokenService.CommonService();
            tokenService.Url = StagingTokenServiceUri;

            string userName = ConfigurationManager.AppSettings["VETokenServiceUsername"];
            string password = ConfigurationManager.AppSettings["VETokenServicePassword"];
            tokenService.Credentials = new System.Net.NetworkCredential(userName, password);

            // Set the token specification properties
            VETokenService.TokenSpecification tokenSpec = new VETokenService.TokenSpecification
            {
                ClientIPAddress = "127.0.0.1",
                TokenValidityDurationMinutes = 60
            };

            // Get a token
            try
            {
                token = tokenService.GetClientToken(tokenSpec);
            }
            catch (Exception ex)
            {
                throw new Exception(string.Format("Token Service Exception: {0}", ex.Message));
            }

            return token;
        }
    }
}
